/****************************************************************************
 *	Copylight(C) 2010 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	WaveFile.cpp
 *
 *	@brief	WAVEt@C̓ǂݍ.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include "WaveFile.h"

//! WAVEt@Cwb_\.
typedef struct {
	DWORD		RiffId;					// RIFFt@Cʎq (RIFF).
	DWORD		FileSize;				// t@CTCY - 8.
	DWORD		FileType;				// t@C^Cv ("WAVE").
	DWORD		FormatId;				// tH[}bgʎq ("fmt ").
	DWORD		FormatSize;				// tH[}bgETCY - 8.
	WORD		FormatType;				// tH[}bg^Cv.
	WORD		Channels;				// `l.
	DWORD		SamplesPerSec;			// TvO.
	DWORD		AvgBytesPerSec;			// 1b̃oCg.
	WORD		BlockAlign;				// 1`l̃oCg.
	WORD		BitsPerSample;			// 1f[^̃rbg.
} WAVFILEHEADER;

//! t@Ng`NEwb_\.
typedef struct {
	DWORD		Id;						// f[^ʎq("fact").
	DWORD		Size;					// `NTCY - 8.
	DWORD		Samples;				// STv.
} WAVEFACTCHUNK;

//! f[^`NEwb_\.
typedef struct {
	DWORD		Id;						// f[^ʎq("data").
	DWORD		Size;					// f[^ETCY.
} WAVEDATACHUNK;

// [Jϐ.
static HANDLE			hFile = NULL;	// t@CEnh.
static WAVFILEHEADER	Header;			// WAVEt@C̃wb_\.

#define	RIFFCC( _x )	(((_x >> 24) & 0xFF) + ((_x >> 8) & 0xFF00) + ((_x << 8) & 0xFF0000) + ((_x << 24) & 0xFF000000))

/****************************************************************************/
/*!
 *	@brief	t@Cǂݍ݃[hŃI[v.
 *
 *	@param	[in]	file_name	t@C̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL	ReadOpenWaveFile( LPCTSTR file_name )
{
	DWORD offset = 0;

	//! Ƀt@CEI[v̏ꍇAG[ɂ.
	if( hFile ){
		return FALSE;
	}
	//! sȏꍇAG[ɂ.
	if( !file_name || _tcslen( file_name ) == 0 ){
		return FALSE;
	}
	//! t@Cǂݍ݃[hŃI[v.
	hFile = CreateFile( file_name, GENERIC_READ, FILE_SHARE_READ, NULL,
									OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, NULL );
	if( hFile == INVALID_HANDLE_VALUE ){
		hFile  = NULL;
		return FALSE;
	}
	//! t@Cwb_͂.
	do {
		//! t@C̐擪Xg[ǂݍ.
		BYTE	buf[256];
		DWORD	len = ReadWaveFile( buf, 256 );
		if( len == 0 ) break;

		//! t@Cwb_o.
		Header  = *((WAVFILEHEADER*)&buf[offset]);
		offset += sizeof(Header);

		//! RIFFwb_𒲂ׂ.
		if(( Header.RiffId   != RIFFCC( 'RIFF' ) )
		|| ( Header.FileType != RIFFCC( 'WAVE' ) )
		|| ( Header.FileSize <= (sizeof(Header) - 8) )){
			break;
		}
		//! tH[}bgwb_𒲂ׂ.
		if(( Header.FormatId       != RIFFCC( 'fmt ' ) )
		|| ( Header.Channels       ==  0 )
		|| ( Header.SamplesPerSec  ==  0 )
		|| ( Header.AvgBytesPerSec ==  0 )
		|| ( Header.BlockAlign     ==  0 )
		|| ( Header.BitsPerSample  ==  0 )
		|| ( Header.FormatSize     <  16 )){
			break;
		}
		for( ; offset < 256 && buf[offset] == 0; offset++ ) ;

		//! t@Ng`No.
		WAVEFACTCHUNK fact;
		fact = *((WAVEFACTCHUNK*)&buf[offset]);
		if( fact.Id == RIFFCC( 'fact' ) ){
			offset += sizeof(WAVEFACTCHUNK);
		}else{
			fact.Samples = 0;
		}
		for( ; offset < 256 && buf[offset] == 0; offset++ ) ;

		//! f[^wb_o.
		WAVEDATACHUNK data;
		data    = *((WAVEDATACHUNK*)&buf[offset]);
		offset += sizeof(WAVEDATACHUNK);

		//! f[^wb_𒲂ׂ.
		if( data.Id != RIFFCC( 'data' ) || data.Size == 0 ){
			break;
		}
		//! t@Cǂݍ񂾃f[^ȂꍇAG[ɂ.
		if( len <= offset ){
			break;
		}
		//! t@C̓ǂݍ݈ʒu擪t[ɍ킹Ă.
		LARGE_INTEGER pos1,pos2;
		pos1.QuadPart = offset;
		SetFilePointerEx( hFile, pos1, &pos2, FILE_BEGIN );

		return TRUE;

	} while( FALSE );

	//! G[̏ꍇAt@CN[YďI.
	CloseWaveFile();
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	t@CEN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	CloseWaveFile( void )
{
	//! I[ṽt@CꍇAt@CN[Y.
	if( hFile ){
		CloseHandle( hFile );
	}
	hFile = NULL;
}

/****************************************************************************/
/*!
 *	@brief	t@CWAVEf[^ǂݍ.
 *
 *	@param	[in]	data	WAVEf[^i[̈̃|C^.
 *	@param	[in]	size	WAVEf[^i[̈̃oCg.
 *
 *	@retval	t@Cǂݍ񂾃oCg.
 */
DWORD	ReadWaveFile( void* data, DWORD size )
{
	DWORD len = 0;

	//! t@Cf[^ǂݍ.
	if( hFile ){
		if( ReadFile( hFile, data, size, &len, NULL ) ){
			return len;
		}
	}
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@CI[vǂ𒲂ׂ.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = t@CEI[v / FALSE = t@CEI[vĂȂ.
 */
BOOL	IsOpenWaveFile( void )
{
	return hFile ? TRUE : FALSE;
}

/****************************************************************************/
/*!
 *	@brief	I[fBIEtH[}bgo.
 *
 *	@param	[out]	wf	I[fBIEtH[}bgi[\̂̃|C^.
 *
 *	@retval	I[fBIEtH[}bgi[\̂̃|C^.
 */
WAVEFORMATEX*	GetAudioFormat( WAVEFORMATEX* wf )
{
	if( wf ){
		wf->wFormatTag      = WAVE_FORMAT_PCM;
		wf->nChannels       = Header.Channels;
		wf->wBitsPerSample  = Header.BitsPerSample;
		wf->nBlockAlign     = Header.BlockAlign;
		wf->nSamplesPerSec  = Header.SamplesPerSec;
		wf->nAvgBytesPerSec = Header.AvgBytesPerSec;
		wf->cbSize          = 0;
	}
	return wf;
}

/* End of file */
