/****************************************************************************
 *	Copylight(C) 2010 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	sample_0002.cpp
 *
 *	@brief	DirectSound𗘗pTEho̓vO.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <commctrl.h>
#include <dsound.h>
#include <tchar.h>
#include <math.h>
#include "resource.h"
#include "WaveFile.h"

// ֐vg^Cv.
static LRESULT CALLBACK	SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
static void				OnInitDialog( HWND hDlg );
static BOOL CALLBACK	DSEnumCallback( LPGUID guid, LPCTSTR desc, LPCTSTR module, LPVOID user );
static BOOL				OnSelectFile( HWND hDlg );
static BOOL				PlaySoundOutput( HWND hDlg );
static void				PauseSoundOutput( HWND hDlg );
static void				StopSoundOutput( HWND hDlg );
static BOOL				OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundOutputDevice( void );
static DWORD WINAPI		OutputEventTask( void* user );
static long				VolumeControl( HWND hVolume );
static long				BalanceControl( HWND hVolume );

// [Jϐ.
static BYTE*				DataBuff;					// f[^obt@.
static DWORD				DataSize;					// f[^TCY.
static DWORD				DevCnt;						// o̓foCX̌.
static GUID					DevGuid[10];				// o̓foCXGUIDe[u.
static TCHAR				DevName[10][64];			// o̓foCX̖Oe[u.
static BOOL					OutState;					// TRUE = TEho͏.
static BOOL					WaveEnd;					// TRUE = WAVf[^I.
static HANDLE				OutEvent[2];				// o̓CxgEIuWFNg.
static DWORD				OutBufSize;					// Xg[obt@ETCY.
static DWORD				OutPos;						// Xg[obt@̏݊Jnʒu.
static int					EndDelay;					// WAVf[^ISTOPR}hsfBCJE^.
static LPDIRECTSOUND8		OutDev;						// IDirectSound8C^[tFCX |C^.
static LPDIRECTSOUNDBUFFER	OutBuf;						// IDirectSoundBufferC^[tFCX |C^.
static TCHAR				FileName[MAX_PATH+1];		//!< ĐWAVt@C̃t@C.


/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	//! [Jϐ.
	DataBuff   = NULL;
	DataSize   = 0;
	DevCnt     = 0;
	OutState   = FALSE;
	WaveEnd    = FALSE;
	OutBufSize = 0;
	OutPos     = 0;
	EndDelay   = 0;
	OutDev     = NULL;
	OutBuf     = NULL;
	memset( DevGuid , 0, sizeof(DevGuid)  );
	memset( DevName , 0, sizeof(DevName)  );
	memset( OutEvent, 0, sizeof(OutEvent) );
	memset( FileName, 0, sizeof(FileName) );

	//! RRg[.
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC  = ICC_COOL_CLASSES;
	InitCommonControlsEx( &ic );

	//! _CAOI[v.
	DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)SoundOutProc );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	_CAÕbZ[WEnh.
 *
 *	@param	[in]	hDlg	_CAO{bNX̃nh.
 *	@param	[in]	msg		bZ[W.
 *	@param	[in]	wParam	ŏ̃bZ[Wp[^.
 *	@param	[in]	lParam	2Ԗڂ̃bZ[Wp[^.
 *
 *	@retval	TRUE  = bZ[W.
 *	@retval	FALSE = bZ[WȂ.
 */
static LRESULT CALLBACK		SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ){
	case WM_INITDIALOG:
		OnInitDialog( hDlg );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_FILE_SELECT:
			OnSelectFile( hDlg );
			break;

		case IDC_PLAY:
			PlaySoundOutput( hDlg );
			break;

		case IDC_PAUSE:
			PauseSoundOutput( hDlg );
			break;

		case IDC_STOP:
			StopSoundOutput( hDlg );
			break;

		case IDCANCEL:
			StopSoundOutput( hDlg );
			EndDialog( hDlg, 0 );
			break;

		default:
			return FALSE;
		}
		break;

	case WM_VSCROLL:
		if( GetDlgItem( hDlg, IDC_VOLUME ) == (HWND)lParam ){
			VolumeControl( (HWND)lParam );
		}
		break;

	case WM_HSCROLL:
		if( GetDlgItem( hDlg, IDC_BALANCE ) == (HWND)lParam ){
			BalanceControl( (HWND)lParam );
		}
		break;

	default:
		break;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	_CAȌ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		OnInitDialog( HWND hDlg )
{
	//! DirectSound̏o̓foCXXgAbv.
	DevCnt = 0;
	DirectSoundEnumerate( DSEnumCallback, (void*)0 );

	//! o̓foCXXg쐬.
	if( DevCnt != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_OUTPUT_DEVICE );
		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < DevCnt; i++ ){
			ComboBox_AddString( hlist, DevName[i] );
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	//! ʃ{[̃gbNo[ݒ肷.
	HWND hbar = GetDlgItem( hDlg, IDC_VOLUME );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );

	//! ʃoX̃gbNo[ݒ肷.
	hbar = GetDlgItem( hDlg, IDC_BALANCE );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );
}

/****************************************************************************/
/*!
 *	@brief	o̓foCX񋓎̃R[obN֐.
 *
 *	@param	[in]	guid	foCXʂGIUD.
 *	@param	[in]	desc	DirectSoundfoCX̐.
 *	@param	[in]	module	DirectSoundhCõW[.
 *	@param	[in]	user	[U[`ϐ (͎gpȂ).
 *
 *	@retval	TRUE = ̃foCX擾 / FALSE = foCX̗񋓂I.
 */
static BOOL CALLBACK	DSEnumCallback( LPGUID guid, LPCTSTR desc, LPCTSTR module, LPVOID user )
{
	//! mۂĂ郊XgTCY𒴂Ă܂ꍇAfoCX̗񋓂I.
	if( DevCnt >= 10 ){
		return FALSE;
	}
	//! "vC} foCX"̓XgɓȂ.
	if( !guid || !desc ){
		return TRUE;
	}
	//! o̓foCXGUIDۑ.
	DevGuid[DevCnt] = *guid;

	//! o̓foCXۑ.
	_tcsncpy_s( DevName[DevCnt], desc, 63 );

	//! o̓foCX̌+1.
	DevCnt++;
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	ĐWAVt@CI.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static BOOL		OnSelectFile( HWND hDlg )
{
	//! TEho͂t@Ct@CI_CAOI.
	OPENFILENAME ofn;
	memset( &ofn     , 0, sizeof(ofn)      );
	memset( &FileName, 0, sizeof(FileName) );
	ofn.lStructSize    = sizeof(ofn);
	ofn.hwndOwner      = hDlg;
	ofn.lpstrFilter    = _T("WAVEt@C(*.wav)\0*.wav\0SẴt@C(*.*)\0*.*\0\0");
	ofn.lpstrFile      = FileName;
	ofn.nMaxFile       = MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt    = NULL;
	ofn.lpstrTitle     = _T("Đt@C");
	if( GetOpenFileName( &ofn ) ){
		SetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName );
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@CĐ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		PlaySoundOutput( HWND hDlg )
{
	//! WAVt@CI[vĂȂꍇAI[v.
	if( !IsOpenWaveFile() ){

		//! -1._CAOĐWAVt@C擾.
		GetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName, sizeof(FileName) - 1 );

		//! -2.ĐWAVt@CI[v.
		if( !ReadOpenWaveFile( FileName ) ){
			MessageBox( hDlg, _T("t@CI[vł܂"), _T("WAVt@C̍Đ"), MB_OK );
			return FALSE;
		}
		WaveEnd  = FALSE;
		EndDelay = 0;
	}
	if( !OutDev ){
		//! I[vWAVt@C̃I[fBIEtB[}bg擾.
		WAVEFORMATEX wf;
		GetAudioFormat( &wf );

		//! TEho̓foCXI[v.
		UINT num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ) );
		if( OpenSoundOutDevice( hDlg, num, &wf ) ){
			//! WAVt@C̓ǂݍݗpobt@mۂ.
			if( !DataBuff ){
				DataSize = wf.nAvgBytesPerSec >> 2;		// 1sec / 4 = 250ms.
				DataBuff = new BYTE[DataSize];
			}
			//! {[ݒ_CAO̐ݒɂ킹.
			VolumeControl( GetDlgItem( hDlg, IDC_VOLUME ) );

			//! oXݒ_CAO̐ݒɂ킹.
			VolumeControl( GetDlgItem( hDlg, IDC_BALANCE ) );

			//! ĐJ[\̈ʒu.
			OutPos = 0;
			OutBuf->SetCurrentPosition( 0 );
		}
	}
	//! TEho͂Jn.
	OutBuf->Play( 0, 0, DSBPLAY_LOOPING );

	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), FALSE );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đꎞ~.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		PauseSoundOutput( HWND hDlg )
{
	//! TEho͂~.
	if( OutBuf ){
		OutBuf->Stop();
	}
	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đ~.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		StopSoundOutput( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundOutputDevice();

	//! ĐWAVt@CN[Y.
	CloseWaveFile();

	//! WAVt@C̓ǂݍݗpobt@.
	if( DataBuff ){
		delete [] DataBuff;
		DataBuff = NULL;
	}
	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! DirectSound̍ĐIuWFNg쐬.
    if( DirectSoundCreate8( &DevGuid[num], &OutDev, NULL ) != S_OK ){
		return FALSE;
	}
	//! ĐIuWFNgɑ΂AvP[V̋xݒ肷.
	if( OutDev->SetCooperativeLevel( hDlg, DSSCL_PRIORITY ) != DS_OK ){
		return FALSE;
	}
	//! Xg[obt@EIuWFNg쐬.
	DSBUFFERDESC desc;
	memset( &desc, 0, sizeof(desc) );
    desc.dwSize  = sizeof(desc);
	desc.dwFlags = DSBCAPS_GLOBALFOCUS
				 | DSBCAPS_CTRLPOSITIONNOTIFY
				 | DSBCAPS_CTRLVOLUME
				 | DSBCAPS_CTRLPAN;
	desc.dwBufferBytes = wf->nAvgBytesPerSec >> 2;
    desc.lpwfxFormat   = wf;
	if( OutDev->CreateSoundBuffer( &desc, &OutBuf, NULL ) != DS_OK ){
		return FALSE;
	}
	//! mۂꂽXg[obt@̃TCY擾.
	DSBCAPS caps;
	memset( &caps, 0, sizeof(caps) );
	caps.dwSize = sizeof(caps);
	if( OutBuf->GetCaps( &caps ) == DS_OK ){
		OutBufSize = caps.dwBufferBytes;
	}
	//! ĐCxg̃IuWFNg쐬.
	for( int i = 0; i < 2; i++ ){
		OutEvent[i] = CreateEvent( NULL, FALSE, FALSE, NULL );
	}
	LPDIRECTSOUNDNOTIFY8 Notify;
	if( OutBuf->QueryInterface( IID_IDirectSoundNotify, (LPVOID*)&Notify ) != DS_OK ){
		return FALSE;
	}
	//! ĐCxgݒ肷.
	DSBPOSITIONNOTIFY pos[2];
	pos[0].dwOffset     = (OutBufSize / 2) - 1;
	pos[0].hEventNotify = OutEvent[0];
	pos[1].dwOffset     = OutBufSize - 1;
	pos[1].hEventNotify = OutEvent[1];
	Notify->SetNotificationPositions( 2, pos );
	Notify->Release();

	OutState = TRUE;

	//! Cxg^XNN.
	DWORD tid;
	CreateThread( NULL, 0, OutputEventTask, (void*)hDlg, 0, &tid );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundOutputDevice( void )
{
	if( OutDev || OutBuf ){
		//! TEho͂~.
		if( OutBuf ){
			OutBuf->Stop();
		}
		//! CxgĎ^XN~.
		OutState = FALSE;
		if( OutEvent[0] ){
			SetEvent( OutEvent[0] );
			Sleep( 500 );
		}
		//! DirectSound̃Xg[obt@.
		if( OutBuf ){
			OutBuf->Release();
			OutBuf = NULL;
		}
		//! DirectSound̍ĐIuWFNg.
		if( OutDev ){
			OutDev->Release();
			OutDev = NULL;
		}
		//! ĐCxg̃IuWFNg.
		for( int i = 0; i < 2; i++ ){
			if( OutEvent[i] ){
				CloseHandle( OutEvent[i] );
				OutEvent[i] = NULL;
			}
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	f[^o̓CxgĎ^XN.
 *
 *	@param	[in]	user	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static DWORD WINAPI		OutputEventTask( void* user )
{
	while( OutState ){
		switch( WaitForMultipleObjects( 2, OutEvent, 0, INFINITE ) ){
		case WAIT_OBJECT_0 + 0:
		case WAIT_OBJECT_0 + 1:
			if( OutState ){
				//! ݂̍ĐJ[\̈ʒu擾.
				DWORD n        = OutBufSize - OutPos;
				DWORD play_pos = 0;
				DWORD dummy    = 0;
				OutBuf->GetCurrentPosition( &play_pos, &dummy );

				/*
				 * ĐJ[\ƃobt@̎̃f[^̏݊Jnʒu
	 			 * ݉\ȗ̈̃oCgvZ.
				 */
				if( play_pos > OutPos ){
					n = play_pos - OutPos;
				}else
				if( play_pos < OutPos ){
					n = (OutBufSize - OutPos) + play_pos;
				}
				if( n > DataSize ) n = DataSize;

				//! WAVt@CĐf[^ǂݍ.
				memset( DataBuff, 0, n );
				DWORD len = ReadWaveFile( DataBuff, n );
				if( len < n ){
					memset( &DataBuff[len], 0, n - len );
				}
				if( len == 0 && !WaveEnd ){
					WaveEnd  = TRUE;
					EndDelay = 3;
				}
				//! f[^ޗ̈bN.
				void*	buf1 = NULL;
				void*	buf2 = NULL;
				DWORD	len1 = 0;
				DWORD	len2 = 0;
				OutBuf->Lock( OutPos, n, &buf1, &len1, &buf2, &len2, 0 );

				//! ݃obt@ɑMf[^Rs[.
				if( buf1 && len1 ){
					memcpy( buf1, DataBuff, len1 );
					OutPos += len1;
				}
				//! ݗ̈悪obt@̐擪ɖ߂ꍇAc̃f[^Rs[.
				if( buf2 && len2 ){
					memcpy( buf2, &DataBuff[len1], len2 );
					OutPos += len2;
				}
				//! ̃f[^̏݊JnʒuXV.
				if( OutPos >= OutBufSize ){
					OutPos -= OutBufSize;
				}
				//! obt@̃bN.
				OutBuf->Unlock( buf1, len1, buf2, len2 ); 

				//! ŏIf[^̍ĐÎŁASTOPR}h𔭍s.
				if( WaveEnd ){
					if( EndDelay == 0 ){
						PostMessage( (HWND)user, WM_COMMAND, IDC_STOP, 0 );
					}else{
						EndDelay--;
					}
				}
			}
			break;
		}
	}
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	ʃ{[ݒύX.
 *
 *	@param	[in]	hVolume	{[Rg[o[̃nh.
 *
 *	@retval	V{[ݒl.
 */
static long		VolumeControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇA{[ݒsȂ.
	if( !OutBuf ){
		return 0;
	}
	//! _CAO{[Rg[̈ʒu擾.
	long range  = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	long volume = DSBVOLUME_MIN;
	if( range < 100 ){
		volume = (long)(1000.0 * log10( (100.0 - range) / 100.0 ));
	}
	if( volume < DSBVOLUME_MIN ){
		volume = DSBVOLUME_MIN;
	}else
	if( volume > DSBVOLUME_MAX ){
		volume = DSBVOLUME_MAX;
	}
	//! {[ݒύX.
	OutBuf->SetVolume( volume );

	return volume;
}

/****************************************************************************/
/*!
 *	@brief	ʃoXݒύX.
 *
 *	@param	[in]	hVolume	oXRg[o[̃nh.
 *
 *	@retval	VoXݒl.
 */
static long		BalanceControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇAoXݒsȂ.
	if( !OutBuf ){
		return 0;
	}
	//! _CAOoXRg[̈ʒu擾.
	long range   = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	long balance = ((50 - range) * ((DSBPAN_RIGHT - DSBPAN_LEFT) / 2)) / 100;

	//! oXݒύX.
	OutBuf->SetPan( balance );

	return balance;
}

/* End of file */
